﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms

Partial Public Class Button
    Inherits Control

    Public Sub New()
        'InitializeComponent()
        Me.SetStyle(ControlStyles.AllPaintingInWmPaint Or ControlStyles.UserPaint Or ControlStyles.DoubleBuffer, True)
    End Sub

    Protected Overrides Sub OnResize(ByVal e As EventArgs)
        MyBase.OnResize(e)
        _pressImage = _pressImage.Resize(Size)
        _releaseImage = _releaseImage.Resize(Size)
    End Sub

    Private _pressImage As Image

    Public Property PressImage As Image
        Get
            Return _pressImage
        End Get
        Set(ByVal value As Image)

            If _pressImage IsNot value Then
                _pressImage = value
                _pressImage = _pressImage.Resize(Size)
                Invalidate()
            End If
        End Set
    End Property

    Private _releaseImage As Image

    Public Property ReleaseImage As Image
        Get
            Return _releaseImage
        End Get
        Set(ByVal value As Image)

            If _releaseImage IsNot value Then
                _releaseImage = value
                _releaseImage = _releaseImage.Resize(Size)
                Invalidate()
            End If
        End Set
    End Property

    Private _isOn As Boolean

    Public Property IsOn As Boolean
        Get
            Return _isOn
        End Get
        Set(ByVal value As Boolean)

            If _isOn <> value Then
                _isOn = value
                Invalidate()
            End If
        End Set
    End Property

    Protected Overrides Sub OnMouseDown(ByVal e As MouseEventArgs)
        _isOn = Not _isOn
        MyBase.OnMouseDown(e)
        Invalidate()
    End Sub

    Protected Overrides Sub OnPaint(ByVal pe As PaintEventArgs)
        If _isOn Then

            If _pressImage IsNot Nothing Then
                pe.Graphics.DrawImage(_pressImage, ClientRectangle)
            End If
        Else

            If _releaseImage IsNot Nothing Then
                pe.Graphics.DrawImage(_releaseImage, ClientRectangle)
            End If
        End If

        MyBase.OnPaint(pe)
    End Sub
End Class
