﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.IO
Imports System.Linq
Imports System.Reflection
Imports System.Text
Imports System.Threading
Imports System.Windows.Forms
Imports Comfile.ComfilePiVB

Namespace Comfile.ComfilePi.GPIOTestVB
    Partial Public Class Form1
        Inherits Form

        Public Sub New()
            InitializeComponent()
            Dim asm = Assembly.GetExecutingAssembly()
            Cursor = New Cursor(New MemoryStream(My.Resources.hiddencursor))
        End Sub

        Private _lamps As Dictionary(Of UInteger, Lamp)
        Private _buttons As Dictionary(Of UInteger, Button)
        Private _pollingThread As Thread
        Private _stopThread As Boolean = False

        Private Sub PollGPIO()
            While Not _stopThread
                Dim result = BeginInvoke(New Action(Sub()

                                                        For Each Input In GPIO.Inputs
                                                            _lamps(Input.Number).IsOn = Input.IsOn
                                                        Next

                                                        For Each output In GPIO.Outputs
                                                            output.IsOn = _buttons(output.Number).IsOn
                                                        Next
                                                    End Sub))

                While Not _stopThread AndAlso Not result.IsCompleted
                    Thread.Sleep(1)
                End While
            End While
        End Sub

        Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
            _lamps = New Dictionary(Of UInteger, Lamp)()
            _lamps.Add(GPIO.Input04.Number, lamp1)
            _lamps.Add(GPIO.Input05.Number, lamp2)
            _lamps.Add(GPIO.Input06.Number, lamp3)
            _lamps.Add(GPIO.Input07.Number, lamp4)
            _lamps.Add(GPIO.Input08.Number, lamp5)
            _lamps.Add(GPIO.Input09.Number, lamp6)
            _lamps.Add(GPIO.Input10.Number, lamp7)
            _lamps.Add(GPIO.Input11.Number, lamp8)
            _lamps.Add(GPIO.Input12.Number, lamp9)
            _lamps.Add(GPIO.Input13.Number, lamp10)
            _lamps.Add(GPIO.Input16.Number, lamp11)
            _buttons = New Dictionary(Of UInteger, Button)()
            _buttons.Add(GPIO.Output17.Number, button1)
            _buttons.Add(GPIO.Output18.Number, button2)
            _buttons.Add(GPIO.Output19.Number, button3)
            _buttons.Add(GPIO.Output20.Number, button4)
            _buttons.Add(GPIO.Output21.Number, button5)
            _buttons.Add(GPIO.Output22.Number, button6)
            _buttons.Add(GPIO.Output23.Number, button7)
            _buttons.Add(GPIO.Output24.Number, button8)
            _buttons.Add(GPIO.Output25.Number, button9)
            _buttons.Add(GPIO.Output26.Number, button10)
            _buttons.Add(GPIO.Output27.Number, button11)
            _pollingThread = New Thread(AddressOf PollGPIO)
            _pollingThread.IsBackground = True
            _pollingThread.Start()
        End Sub

        Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles MyBase.FormClosing
            _stopThread = True
            _pollingThread.Join()
        End Sub

        Private Sub lamp1_Click(ByVal sender As Object, ByVal e As EventArgs)
        End Sub

        Private Sub label3_Click(ByVal sender As Object, ByVal e As EventArgs)
        End Sub

        Private Sub button12_Click(sender As Object, e As EventArgs) Handles button12.Click
            Close()
        End Sub
    End Class
End Namespace
