﻿Imports System
Imports System.Collections.Generic
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Runtime.CompilerServices

Public Module ImageExtensions
    <Extension()>
    Function Resize(ByVal imgToResize As Image, ByVal sz As Size) As Image
        If imgToResize Is Nothing OrElse sz = Size.Empty Then
            Return imgToResize
        End If

        Dim sourceWidth As Integer = imgToResize.Width
        Dim sourceHeight As Integer = imgToResize.Height
        Dim nPercent As Single = 0
        Dim nPercentW As Single = 0
        Dim nPercentH As Single = 0
        nPercentW = (CSng(sz.Width) / CSng(sourceWidth))
        nPercentH = (CSng(sz.Height) / CSng(sourceHeight))

        If nPercentH < nPercentW Then
            nPercent = nPercentH
        Else
            nPercent = nPercentW
        End If

        Dim destWidth As Integer = CInt((sourceWidth * nPercent))
        Dim destHeight As Integer = CInt((sourceHeight * nPercent))
        Dim b As Bitmap = New Bitmap(destWidth, destHeight)
        Dim g As Graphics = Graphics.FromImage(CType(b, Image))
        g.InterpolationMode = InterpolationMode.HighQualityBicubic
        g.DrawImage(imgToResize, 0, 0, destWidth, destHeight)
        g.Dispose()
        Return b
    End Function
End Module
