﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Linq
Imports System.Resources
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms
Imports System.Reflection


Partial Public Class Lamp
    Inherits Control

    Public Sub New()
        'InitializeComponent()
        Me.SetStyle(ControlStyles.AllPaintingInWmPaint Or ControlStyles.UserPaint Or ControlStyles.DoubleBuffer, True)
    End Sub

    Protected Overrides Sub OnResize(ByVal e As EventArgs)
        MyBase.OnResize(e)
        _onImage = _onImage.Resize(Size)
        _offImage = _offImage.Resize(Size)
    End Sub

    Private _onImage As Image

    Public Property OnImage As Image
        Get
            Return _onImage
        End Get
        Set(ByVal value As Image)

            If _onImage IsNot value Then
                _onImage = value
                _onImage = _onImage.Resize(Size)
                Invalidate()
            End If
        End Set
    End Property

    Private _offImage As Image

    Public Property OffImage As Image
        Get
            Return _offImage
        End Get
        Set(ByVal value As Image)

            If _offImage IsNot value Then
                _offImage = value
                _offImage = _offImage.Resize(Size)
                Invalidate()
            End If
        End Set
    End Property

    Private _isOn As Boolean

    Public Property IsOn As Boolean
        Get
            Return _isOn
        End Get
        Set(ByVal value As Boolean)

            If _isOn <> value Then
                _isOn = value
                Invalidate()
            End If
        End Set
    End Property

    Protected Overrides Sub OnPaint(ByVal pe As PaintEventArgs)
        If IsOn Then

            If _onImage IsNot Nothing Then
                pe.Graphics.DrawImage(_onImage, ClientRectangle)
            End If
        Else

            If _offImage IsNot Nothing Then
                pe.Graphics.DrawImage(_offImage, ClientRectangle)
            End If
        End If

        MyBase.OnPaint(pe)
    End Sub
End Class
